version: '3.5'

services:
    nginx:
      build:
        context: ./nginx
      volumes:
        - ${APP_CODE_PATH_HOST}:${APP_CODE_PATH_CONTAINER}
        - ${NGINX_HOST_LOG_PATH}:/var/log/nginx
        - ${NGINX_SITE_PATH}:/etc/nginx/sites-available/mysite.conf
        - ${NGINX_SSL_PATH}:/etc/nginx/ssl
      ports:
        - "${NGINX_HOST_HTTP_PORT}:80"
        - "${NGINX_HOST_HTTPS_PORT}:443"
      depends_on:
        - mysite      
      networks:
        - backend
        - frontend

    mysite:
      build:
        context: ./mysite
        args:
          - INSTALL_GIT=${INSTALL_GIT}
          - INSTALL_ZIP=${INSTALL_ZIP}
          - INSTALL_NPM=${INSTALL_NPM}
          - INSTALL_CRON=${INSTALL_CRON}
          - WORK_DIR=${APP_CODE_PATH_CONTAINER}
          - NODE_VERSION=${NODE_VERSION}
      volumes:
        - type: bind
          source: ./mysite/cron/crontab
          target: /etc/crontab  
        - type: bind
          source: ${APP_CODE_PATH_HOST}
          target: ${APP_CODE_PATH_CONTAINER}
      # ports:
      #   - 9000:9000
      #   - 9001:80
      depends_on:
        - db
        - redis
      networks:
        - backend

    consumers:
      build:
        context: ./consumers
        args:
          - INSTALL_GIT=${INSTALL_GIT}
          - INSTALL_ZIP=${INSTALL_ZIP}
          - INSTALL_NPM=${INSTALL_NPM}
          - INSTALL_CRON=${INSTALL_CRON}
          - INSTALL_SUPERVISOR=${INSTALL_SUPERVISOR}
          - WORK_DIR=${APP_CODE_PATH_CONTAINER}
      volumes:
          - ./consumers/supervisor/mysite.conf:/etc/supervisor/conf.d/mysite.conf 
          - ${APP_CODE_PATH_HOST}:${APP_CODE_PATH_CONTAINER}
      depends_on:
        - db
        - redis
      networks:
        - backend

    db:
      build:
        context: ./mysql
        args:
          - MYSQL_VERSION=${MYSQL_VERSION}
      environment:
        - MYSQL_DATABASE=${MYSQL_DATABASE}
        - MYSQL_USER=${MYSQL_USER}
        - MYSQL_PASSWORD=${MYSQL_PASSWORD}
        - MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}
        - TZ=${WORKSPACE_TIMEZONE}
      volumes:
        - ${DATA_PATH_HOST}/mysql:/var/lib/mysql
        - ${MYSQL_ENTRYPOINT_INITDB}:/docker-entrypoint-initdb.d
      ports:
        - "${MYSQL_PORT}:3306"
      networks:
        - backend

    redis:
      build:
        context: ./redis
      volumes:
        - ${DATA_PATH_HOST}/redis:/data
      ports:
        - "${REDIS_PORT}:6379"
      networks:
        - backend            

networks:
  frontend:
    driver: ${NETWORKS_DRIVER}
  backend:
    driver: ${NETWORKS_DRIVER}

volumes:
  db:
    driver: ${VOLUMES_DRIVER}   
  redis:
    driver: ${VOLUMES_DRIVER}
  mysite_data:
      driver: local
      driver_opts:
        type: 'none'
        o: 'bind'
        device: ${APP_CODE_PATH_HOST} 
    
